<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:template match="/">
	<xsl:apply-templates select="*" mode="struct"/>
	<xsl:apply-templates select="*" mode="usage"/>
	<xsl:apply-templates select="*" mode="fn_top"/>
	<xsl:apply-templates select="*" mode="while"/>
	<xsl:apply-templates select="*" mode="body"/>
</xsl:template>

<xsl:template match="project" mode="body">
	<xsl:text>	switch (c) {
</xsl:text>
	<xsl:apply-templates select="option" mode="body"/>
	<xsl:apply-templates select="argument" mode="body"/>
	<xsl:text>		}
	}
}
</xsl:text>
</xsl:template>

<xsl:template match="project/option" mode="body">
	<xsl:text>		case '</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>':
			settings-&gt;</xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text> = 1;
			break;
</xsl:text>
</xsl:template>

<xsl:template match="project/argument" mode="body">
	<xsl:text>		case '</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>':
			settings-&gt;</xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text> = optarg;
			break;
</xsl:text>
</xsl:template>

<xsl:template match="project" mode="fn_top">
	<xsl:text>void parse_args(int argc, char *argv[], settings_t * settings)
{
	char c;
	int opt_index = 0;
	struct option opts[] = {
</xsl:text>
	<xsl:apply-templates select="option" mode="fn_top"/>
	<xsl:apply-templates select="argument" mode="fn_top"/>
	<xsl:text>		{0, 0, 0, 0}
	};

</xsl:text>
</xsl:template>

<xsl:template match="project/option" mode="fn_top">
	<xsl:text>		{"</xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>", 0, 0, '</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>'},
</xsl:text>
</xsl:template>

<xsl:template match="project/argument" mode="fn_top">
	<xsl:text>		{"</xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>", 1, 0, '</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>'},
</xsl:text>
</xsl:template>

<xsl:template match="project" mode="struct">
	<xsl:text>#include &lt;getopt.h&gt;

typedef struct settings_t {
</xsl:text>
	<xsl:apply-templates select="option" mode="struct"/>
	<xsl:apply-templates select="argument" mode="struct"/>
	<xsl:text>} settings_t;

</xsl:text>
</xsl:template>

<xsl:template match="project/argument" mode="struct">
	<xsl:text>	</xsl:text>
	<xsl:value-of select="type"/>
	<xsl:text> </xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>;
</xsl:text>
</xsl:template>

<xsl:template match="project/option" mode="struct">
	<xsl:text>	int </xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>;
</xsl:text>
</xsl:template>

<xsl:template match="project" mode="usage">
	<xsl:text>char *usage_</xsl:text>
	<xsl:apply-templates select="progname" mode="usage"/>
	<xsl:text>= "
</xsl:text>
	<xsl:apply-templates select="option" mode="usage"/>
	<xsl:apply-templates select="argument" mode="usage"/>
	<xsl:text>";
	
</xsl:text>
</xsl:template>

<xsl:template match="project/option" mode="usage">
	<xsl:text>  </xsl:text>
	<xsl:text>-</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>, </xsl:text>
	<xsl:text>--</xsl:text>
	<xsl:apply-templates select="name" mode="usage"/>
	<xsl:text>	</xsl:text>
	<xsl:apply-templates select="description" mode="usage"/>
	<xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="project/argument" mode="usage">
	<xsl:text>  </xsl:text>
	<xsl:text>-</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>, </xsl:text>
	<xsl:text>--</xsl:text>
	<xsl:apply-templates select="name" mode="usage"/>
	<xsl:text>	</xsl:text>
	<xsl:apply-templates select="description" mode="usage"/>
	<xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="project" mode="while">
	<xsl:text>	while ((c = getopt_long(argc, argv, "</xsl:text>
	<xsl:apply-templates select="option" mode="while"/>
	<xsl:apply-templates select="argument" mode="while"/>
	<xsl:text>", opts, &amp;opt_index)) &gt;= 0) {
	</xsl:text>
	<xsl:apply-templates select="footer" mode="while"/>
</xsl:template>

<xsl:template match="project/option" mode="while">
	<xsl:value-of select="substring (name, 1, 1)"/>
</xsl:template>

<xsl:template match="project/argument" mode="while">
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>:</xsl:text>
</xsl:template>

</xsl:stylesheet>
